package pw.yumc.MenuProtect.utils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

import cn.citycraft.PluginHelper.kit.PluginKit;

public class MarkUtil {
    public static List<String> marks = null;
    public static Map<String, List<String>> cmds = new HashMap<>();

    public static void handlerItemClick(final Player p, final ItemStack is) {
        if (hasMark(is) && is.getItemMeta().hasLore()) {
            for (final String lore : is.getItemMeta().getLore()) {
                if (cmds.containsKey(lore)) {
                    for (final String cmd : cmds.get(lore)) {
                        PluginKit.runTask(new Runnable() {
                            @Override
                            public void run() {
                                CommandSender sender = Bukkit.getConsoleSender();
                                if (cmd.startsWith("[p]")) {
                                    sender = p;
                                }
                                final String rcmd = cmd.replaceAll("%player%", p.getName());
                                Bukkit.dispatchCommand(sender, rcmd.startsWith("[") ? rcmd.substring(3) : rcmd);
                            }
                        });
                    }
                }
            }
        }
    }

    public static boolean hasMark(final ItemStack ci) {
        try {
            for (final String mark : marks) {
                if (ci.getItemMeta().getDisplayName().startsWith(mark)) {
                    return true;
                }
            }
        } catch (final Exception e) {
        }
        return false;
    }

    public static void initCommand(final ConfigurationSection cfg) {
        cmds.clear();
        for (final String lore : cfg.getKeys(false)) {
            cmds.put(lore, cfg.getStringList(lore));
        }
        PluginKit.getLogger().info("初始化LoreCommand完毕 总计: " + cmds.size() + "条...");
    }
}
